=== debian/changelog ===
libsecp256k1 (0.6.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Soren Stoutner <soren@debian.org>  Wed, 05 Nov 2025 12:09:05 -0700

libsecp256k1 (0.6.0-1) experimental; urgency=medium

  * New Upstream Release

  [ Manuel Guerra ]
  * New Maintainer Upload
  * Add file debian/salsa-ci.yml to manage Salsa's CI
  * Update file format and stanzas in copyright:
    - Set files: * stanza.
    - Format text to fit 80 columns.
    - Rewrite stanzas format for more comfortable lecture.
    - Add license paragraph for GPL-3+, CC0-1.0 and Apache-2.0.
  * Update debian/control file:
    - Update uploaders list to include new co-maintainers.
    - Bump Standards-Version to 4.7.2 (no changes required).
    - Reformat text file to fit 80 columns.
    - Change library package name to libsecp256k1-5.
  * Update debian/watch file to a simpler format.
  * Add debian/upstream/metadata file.
  * Update .symbols file:
    - Remove debian/libsecp256k1-2.symbols file.
    - Add new debian/libsecp256k1-5.symbols file.
  * Add debian/libsecp256k1-dev.install file to install examples
  * Remove obsolete debian/source/lintian-overrides.
  * Add hardening options in debian/rules.

  [ Soren Stoutner ]
  * Remove debian/upstream/signing-key.asc as upstream does not release signed
    tarballs.
  * debian/control:  Remove Jonas Smedegaard <dr@jones.dk> as an uploader
    according to his instructions.

 -- Manuel Guerra <ar.manuelguerra@gmail.com>  Sat, 09 Aug 2025 08:27:23 -0300
