=== debian/control ===
Source: libsecp256k1
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               pkgconf,
               libgmp-dev,
               autoconf-archive,
               libssl-dev,
               d-shlibs,
               pkg-kde-tools
Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
Uploaders: Soren Stoutner <soren@debian.org>,
           Manuel Guerra <ar.manuelguerra@gmail.com>
Homepage: https://github.com/bitcoin/secp256k1
Vcs-Git: https://salsa.debian.org/cryptocoin-team/libsecp256k1.git
Vcs-Browser: https://salsa.debian.org/cryptocoin-team/libsecp256k1
Standards-Version: 4.7.2

Package: libsecp256k1-5
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: library for EC operations on curve secp256k1
 An optimized C library for EC operations on curve secp256k1.
 .
 NB! This library is intended to be the highest quality publicly available
 library for cryptography on the secp256k1 curve. However, the primary focus of
 its development has been for usage in the Bitcoin system and usage unlike
 Bitcoin's may be less well tested, verified, or suffer from a less well thought
 out interface. Correct usage requires some care and consideration that the
 library is fit for your application's purpose.
 .
 Features:
  * secp256k1 ECDSA signing/verification and key generation.
  * Additive and multiplicative tweaking of secret/public keys.
  * Serialization/parsing of secret keys, public keys, signatures.
  * Constant time, constant memory access signing and public key generation.
  * Derandomized ECDSA (via RFC6979 or with a caller provided function.)
  * Very efficient implementation.
  * Suitable for embedded systems.
  * Optional module for public key recovery.
  * Optional module for ECDH key exchange.

Package: libsecp256k1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsecp256k1-5 (= ${binary:Version}),
         pkgconf,
         ${devlibs:Depends},
         ${misc:Depends}
Description: library for EC operations on curve secp256k1 - development headers
 An optimized C library for EC operations on curve secp256k1.
 .
 NB! This library is intended to be the highest quality publicly available
 library for cryptography on the secp256k1 curve. However, the primary focus of
 its development has been for usage in the Bitcoin system and usage unlike
 Bitcoin's may be less well tested, verified, or suffer from a less well thought
 out interface. Correct usage requires some care and consideration that the
 library is fit for your application's purpose.
 .
 Features:
  * secp256k1 ECDSA signing/verification and key generation.
  * Additive and multiplicative tweaking of secret/public keys.
  * Serialization/parsing of secret keys, public keys, signatures.
  * Constant time, constant memory access signing and public key generation.
  * Derandomized ECDSA (via RFC6979 or with a caller provided function.)
  * Very efficient implementation.
  * Suitable for embedded systems.
  * Optional module for public key recovery.
  * Optional module for ECDH key exchange.
 .
 This package provides header files for developing your applications to use
 libbitcoin template engine.
