=== debian/watch ===
version=4
https://github.com/bitcoin-core/secp256k1/tags .*/v?(\d.*)\.tar\.gz
