## libsecp256k1 0.7.0

=== debian/changelog ===
libsecp256k1 (0.7.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Manuel Guerra <ar.manuelguerra@gmail.com>  Sat, 06 Dec 2025 18:59:35 +0000

libsecp256k1 (0.7.0-1) experimental; urgency=medium

  * New upstream release.

  [ Manuel Guerra ]
  * debian/watch: Bump to uscan version 5, rewrite source files.
  * debian/control: Update soname version.
  * debian/libsecp256k1-*.symbols: Update to soname version 6.
  * debian/copyright: Update stanzas.

  [ Soren Stoutner ]
  * Add debian/libsecp256k1-6.lintian-overrides to override a
    spelling-error-in-binary flase positive.

 -- Soren Stoutner <soren@debian.org>  Mon, 17 Nov 2025 18:14:06 -0700
