=== debian/watch ===
Version: 5

Template: Github
Owner: bitcoin-core
Project: secp256k1
