## libsecp256k1 0.7.1

=== debian/changelog ===
libsecp256k1 (0.7.1-1) experimental; urgency=medium

  * New upstream version.
  * Update control file: Bump standars version to 4.7.3, remove priority tag.
  * Update year of copyright holders for debian/* stanza in copyright file.
  * Update override libsecp256k1-6.lintian-overrides.
  * Add source lintian-overrides.

 -- Manuel Guerra <ar.manuelguerra@gmail.com>  Wed, 11 Feb 2026 18:59:35 +0000
