=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: libsecp256k1
 Section: libs
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
                pkgconf,
                libgmp-dev,
@@ -14,9 +13,9 @@
 Homepage: https://github.com/bitcoin/secp256k1
 Vcs-Git: https://salsa.debian.org/cryptocoin-team/libsecp256k1.git
 Vcs-Browser: https://salsa.debian.org/cryptocoin-team/libsecp256k1
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 
-Package: libsecp256k1-5
+Package: libsecp256k1-6
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends}
@@ -47,7 +46,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libsecp256k1-5 (= ${binary:Version}),
+Depends: libsecp256k1-6 (= ${binary:Version}),
          pkgconf,
          ${devlibs:Depends},
          ${misc:Depends}
